/*
 * OpenEAS Experlog Application Server
 * Web application development and dynamic template scripting engine
 * Copyright (c) 2004 ExperLog SARL - http://www.experlog.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version. This program is distributed in
 * the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details. You should have
 * received a copy of the GNU General Public License along with this program;
 * if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * Created on 23 sept. 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.experlog.gencode;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.sql.SQLException;
import java.util.Hashtable;

import org.experlog.base.ESServletRequest;
import org.experlog.openeas.api.DataSet;
import org.experlog.openeas.api.DataObject;

/**
 * @author spengler
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public interface DynHtml {
	/**
	 * Display unresolved symbols or not.
	 */
	public abstract void displayUnresolved(boolean yes);
	/**
	 * Change the input file definition
	 * @param file An input file
	 */
	public abstract void setInputFile(File file) throws IOException;
	/**
	 * Change the input file definition
	 * @param file An input file
	 * @param enforceSecurity If true, enforce security check on file name
	 */
	public abstract void setInputFile(File file, boolean enforceSecurity)
		throws IOException;
	/**
	* Define a data set
	* @param ds An ESDataSet object
	*/
	public abstract void addDataSet(String name, DataSet ds);
	/**
	 * Define a data set
	 * @param t An ESDataSet object
	 */
	public abstract void addDataObject(String name, DataObject t);
	/**
	 * Define a new parameter (a tagname/value association)
	 * When $tagname$ will be found, it will be expanded to value.
	 */
	public abstract void setParameter(
		String name,
		String val,
		boolean addtoreq);
	/**
	 * Expand the HTML template on a given output stream.
	 */
	public abstract void expand(PrintWriter out) throws ExitException;
	
	/**
	 * Expand the HTML template on a given output stream.
	 */
	public abstract void expand(PrintWriter out, boolean closeds) throws ExitException;

	public abstract String expandString(String line) throws SQLException;
	public abstract String expandString(String line, Hashtable params)
		throws SQLException;
	public abstract String expandString(
		String line,
		Hashtable params,
		boolean displayUnresolved)
		throws SQLException;
	public void setServletRequest(ESServletRequest req);
	public String sqlEncode(String s, String datasourcename) throws SQLException;
}