/*
 * OpenEAS Experlog Application Server
 * Web application development and dynamic template scripting engine
 * Copyright (c) 2004 ExperLog SARL - http://www.experlog.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version. This program is distributed in
 * the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details. You should have
 * received a copy of the GNU General Public License along with this program;
 * if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */


package org.experlog.gencode;

public class ExpOperand {

  int operator_;
  int valuetype_ = 0; // Type for values: 0 for Numeric, 1 for String

  Object right_ = null;

  Object left_ = null;

  public ExpOperand(int operator, Object left, Object right) {
    operator_ = operator;
    left_ = left;
    right_ = right;
  }

  public ExpOperand(String val) {
    operator_ = ExpParser.VALUE;
    left_ = val;
    valuetype_ = 1;
  }

  public ExpOperand(Double val) {
    operator_ = ExpParser.VALUE;
    left_ = val;
  }


  public int getOperator() { return operator_; }
  public ExpOperand leftTerm() { return (ExpOperand)left_; }
  public ExpOperand rightTerm() { return (ExpOperand)right_; }
  public ExpOperand singleTerm() { return rightTerm(); }

  public boolean isStringValue() {
    return operator_ == ExpParser.VALUE && valuetype_ == 1;
  }
  public double getNumericValue() { return ((Double)left_).doubleValue(); }
  public String getStringValue() { return left_.toString(); }

  public String toString() {
    StringBuffer b = new StringBuffer();
    if(operator_ != ExpParser.VALUE)
      b.append("(" + ExpParser.opString(operator_) + " ");
    if(left_ != null) b.append(left_.toString() + " ");
    if(right_ != null) b.append(right_.toString());
    if(operator_ != ExpParser.VALUE) b.append(")");
    return b.toString();
  }

}

